/*
    bcd (Blacky's CD Player)

    Dies ist ein einfacher CD-Player fr die Shell.

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/types.h>
#include <fcntl.h>     
#include <unistd.h>
#include <mntent.h>
#include <string.h>
#include <errno.h>
#include <linux/cdrom.h>
#include <curses.h>
#include <signal.h>
#include <time.h>
#include "hofmeier.h"


char blacky_ver_info[] = "Blacky's CD-Player v0.66 (c) Copyright 1998 Andreas Hofmeier";


const char cdrom[] = "/dev/cdrom\0";


/* function zum Herunterfahren ! */
static void finish(int sig);
/* UHR function */
static void uhr(int sig);
/* Windowsgre gendert */
static void winversch(int sig);


int repeat = 0;                   /* Repeat ? */
int i, f = -1, start_track, cdid;
int repeat_stat = 1;
int shuffle_stat = 0;
int shuffling = 0;

unsigned long toggles_set;
struct cdrom_tochdr tochdr;
struct cdrom_tocentry tocentry;
struct cdrom_ti ti;
struct cdrom_subchnl subchnl;
struct mntent *mnt;

char swhg = 0;                    /* System wird herruntergefahren */


paint()
{
  if (f < 0)
    {
      /* CD-ROM ffnen */
      f = open(cdrom, 0);
    }
  if (f < 0)
    {
      perror(cdrom);
    }

  if (swhg)
    return;

  makeline(LOECK, HLINE, ROECK, 1, 1);
  makeline(VLINE, NOMBG, VLINE, 1, 2);
  gotoxy(3, 2);
  addstr(blacky_ver_info);
  /*  addstr("Blacky's CD-Rom Player (c) Copyright by Andreas Hofmeier Computer Programme");*/
  makeline(RABGE, HLINE, LABGE, 1, 3);
  makeline(VLINE, NOMBG, VLINE, 1, 4);
  /*  gotoxy(3, 4);
  addstr("");*/
  makeline(VLINE, NOMBG, VLINE, 1, 5);
  /*  gotoxy(3, 5);
  addstr("");*/
  makeline(RABGE, HLINE, LABGE, 1, 6);
  makeline(VLINE, NOMBG, VLINE, 1, 7);
  gotoxy(3, 7);
  addstr("ESC = Exit / P = Pause-Play / UP = Next Track / DN = Last Track / S = Stop");
  makeline(VLINE, NOMBG, VLINE, 1, 8);
  gotoxy(3, 8);
  addstr("ENTER = Select Treck / E = Eject / R = Repeat");
  makeline(VLINE, NOMBG, VLINE, 1, 9);
  /*  gotoxy(3, 9);
  addstr("");*/
  makeline(RABGE, HLINE, LABGE, 1, 10);
  makeline(VLINE, NOMBG, VLINE, 1, 11);
  gotoxy(3, 11);
  addstr("Status     :");
  makeline(VLINE, NOMBG, VLINE, 1, 12);
  gotoxy(3, 12);
  addstr("Track      :");
  makeline(VLINE, NOMBG, VLINE, 1, 13);
  gotoxy(3, 13);
  addstr("gesamt Min :");
  makeline(VLINE, NOMBG, VLINE, 1, 14);
  gotoxy(3, 14);
  addstr("track Min  :");
  makeline(VLINE, NOMBG, VLINE, 1, 15);
  makeline(VLINE, NOMBG, VLINE, 1, 16);
  makeline(VLINE, NOMBG, VLINE, 1, 17);
  makeline(VLINE, NOMBG, VLINE, 1, 18);
  makeline(RABGE, HLINE, LABGE, 1, 19);
  makeline(VLINE, NOMBG, VLINE, 1, 20);
  makeline(VLINE, NOMBG, VLINE, 1, 21);
  makeline(RABGE, HLINE, LABGE, 1, 22);
  makeline(VLINE, NOMBG, VLINE, 1, 23);
  gotoxy(3, 23);
  addstr("COMMAND =>");
  makeline(LUECK, HLINE, RUECK, 1, 24);

  uhr(128);
  paintstatus();
  gotoxy(14, 23);
  refresh();
}


paintstatus()
{
  int i;
  char mull[200];

  if (swhg)
    return;

  /* Informieren */
  subchnl.cdsc_format = CDROM_MSF;
  subchnl.cdsc_audiostatus = CDROM_LEADOUT;
  subchnl.cdsc_trk = CDROM_LEADOUT; 
  ioctl(f, CDROMSUBCHNL, &subchnl);

  if (subchnl.cdsc_audiostatus == CDROM_AUDIO_PLAY/*17*/) {
    strcpy(mull, "Playing...");
  } else {
    if (subchnl.cdsc_audiostatus == CDROM_AUDIO_PAUSED/*18*/) {
      strcpy(mull, "Paused.   ");
    } else {
      if  ((subchnl.cdsc_audiostatus == CDROM_AUDIO_NO_STATUS/*21*/) || (subchnl.cdsc_audiostatus == CDROM_AUDIO_COMPLETED)) {
	strcpy(mull, "Stopped.  ");
      } else {
	strcpy(mull, "Status ERROR!");
      }
    }
  }
  gotoxy(16, 11);
  addstr(mull);

  if ((subchnl.cdsc_audiostatus == 18) || (subchnl.cdsc_audiostatus == 17))
    {
      /* Track */
      gotoxy(16, 12);
      sprintf(mull, "%d", subchnl.cdsc_trk);
      make0(mull, 2);
      addstr(mull);
      /* Min ges. */
      gotoxy(16, 13);
      sprintf(mull, "%d", subchnl.cdsc_absaddr.msf.minute);
      make0(mull, 2);
      addstr(mull);
      addstr(":");
      sprintf(mull, "%d", subchnl.cdsc_absaddr.msf.second);
      make0(mull, 2);
      addstr(mull);
      /* Min tre. */
      gotoxy(16, 14);
      sprintf(mull, "%d", subchnl.cdsc_reladdr.msf.minute);
      make0(mull, 2);
      addstr(mull);
      addstr(":");
      sprintf(mull, "%d", subchnl.cdsc_reladdr.msf.second);
      make0(mull, 2);
      addstr(mull);
      if (repeat != 0)
         {
           gotoxy(3, 15);
           addstr("Repeat     : ");
           if (repeat > 0)
              {
                addstr("Treck : ");
                sprintf(mull, "%d", subchnl.cdsc_trk);
                make0(mull, 2);
                addstr(mull);
                /* Wenn anderer Track, zurcksetzen */
                i = repeat;
                if (subchnl.cdsc_trk != repeat)
                   play(repeat);
                repeat = i;
              }
            else
              {
                addstr("All");
                if (subchnl.cdsc_audiostatus == 18) play(1);
              }
         }
    }
  gotoxy(14, 23);
  refresh();
}


static char *Eingabe(Result, Was, def, al)
  char Result[];
  char Was[];
  char def[];
  int al;
{
  char i;
  echo();
  gotoxy(3, 20);
  addstr(Was);
  if ((def[0] == 0) && (!((def[0] == ' ') && (def[1] == 0))))
    {
      gotoxy(3, 21);
      refresh(); 
      Result[0] = 0;
      editstr(Result, 20, 2, al);
    }
  else
    {
      Result[0] = 0;
      Result[1] = 0;
      if (!((def[0] == ' ') && (def[1] == 0)))
	strcpy(Result, def);
      editstr(Result, 20, 2, al);
    }
  paint();
  noecho();
  return Result;
}


main(argc, argv)
  int argc;
  char *argv[];
{
  char mull[200];
  /*  extern int read_cdrom(); */
  /*  read_cdrom(); */
  FILE *fp;

  struct cdrom_msf infoo;

  allblackyintro(blacky_ver_info);

  if ((argc > 1) ? ((argv[1][0] == '-') && ((argv[1][1] == '?') || (toupper(argv[1][1]) == 'H'))) : 0)
    {
      printf("Help:\n");
      printf("  bcd [-v]\n");
      printf("    -v: Version, Licenze\n");
      exit(0);
    }

  if ((argc == 2) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0)
      {
        printf("%s\n\n", blacky_ver_info);
        printkinfo(stdout);
        exit(0);
      }


  /* check if drive is mounted (from Mark Buckaway's cdplayer code) */
  if ((fp = setmntent (MOUNTED, "r")) == NULL)
    {
      fprintf (stderr, "Couldn't open %s: %s\n", MOUNTED, strerror (errno));
      exit (1);
    }
  while ((mnt = getmntent (fp)) != NULL)
    {
      if (strcmp (mnt->mnt_type, "iso9660") == 0)
	{
	  fputs ("CDROM already mounted. Operation aborted.\n", stderr);
	  endmntent (fp);
	  exit (1);
	}
    }
  endmntent (fp);

  /*  sleep(6);*/

  /* CD-ROM ffnen */
  f = open(cdrom, 0);

  /* Interrups vergeben ... */
  signal(SIGHUP, finish);       /* 01  /  hangup     - Alt-F4                            */
  signal(SIGINT, finish);       /* 02  /  Interrupt  - ^C                                */
  signal(SIGQUIT, finish);      /* 03  /  Quit                                           */
  signal(SIGTERM, finish);      /* 15  /  Terminierung                                   */
  /*     SIGALRM  */
  signal(SIGALRM, uhr);         /* 14  /  Alarm      - wenn gesetzte Zeit abgelaufen ist */
  /* Fenstergre gendert? */
  signal(SIGWINCH, winversch);  /* 28  /  ?          - grennderund des xTerms         */
  /*     SIGALRM  */
  signal(SIGALRM, uhr);

  /* Init curses ... */
  init_cur_graph();

  paint();
  /* ABSOLUTELY NO WARRANTY */
  gotoxy(3, 20);
  addstr("This is free software with ABSOLUTELY NO WARRANTY.");
  gotoxy(3, 21);
  addstr("For details read /home/andreas/.Blacky_NO_WARRANTY.");
  alarm(1);
  /* Hauptschleife */
  do
     {
       gotoxy(14, 23);    
       switch (getch())
         {
	    /* EXIT - ESC oder X*/
	    case 120:
	    case 27:
	    case 'q':
	      finish(0);
	    break;

	    /* Stop */
	    case 's':
	    case 'S':
	      stop();
	    break;

	    /* Play */
	    case 'p':
	    case 'P':
	      pause();
	    break;

	    /* DE PLUS - 'UP' oder '+' */
	    case 259:
            case '+':
	      play(subchnl.cdsc_trk + 1);
	    break;
	      
	    /* DS LAST - 'DN' oder '-' */
	    case 258:
            case '-':
	      play(subchnl.cdsc_trk - 1);
	    break;

	    /* Go To Track - 'ENTER' */
	    case 13:
	    case 343:
	      Eingabe(mull, "Enter Track:", "", 0);
	      i = atoi(mull);
	      play(i);
	    break;

            /* Eject */
            case 'e':
            case 'E':
              eject();
            break;

            /* Repeat */
            case 'r':
            case 'R':
              if (repeat < 1)
                 repeat = subchnl.cdsc_trk;
              else
                 repeat = -1;
            break;

	    /* Redraw - Space */
            case ' ':
	      endwin();
	      paint();
	    break;
	 }
       paint();
     }
  while(1);
}


eject()
{
  if (repeat != 0) repeat = 0;

  stop();
  ioctl(f, CDROMSTOP);
  ioctl(f, CDROMEJECT);
}


play(tr)
  int tr;
{
  if (repeat != 0) repeat = 0;

  subchnl.cdsc_format = CDROM_MSF;
  subchnl.cdsc_audiostatus = CDROM_LEADOUT;
  subchnl.cdsc_trk = CDROM_LEADOUT; 

  ioctl(f, CDROMSUBCHNL, &subchnl);

  if (subchnl.cdsc_audiostatus == CDROM_AUDIO_PAUSED/*18*/) {
    ioctl(f, CDROMRESUME);
    return;
  }

  /* Playing */
  ioctl(f, CDROMREADTOCHDR, &tochdr);
 
  subchnl.cdsc_format = CDROM_MSF;
  subchnl.cdsc_trk = CDROM_LEADOUT;

  /* Init Record */
  ti.cdti_trk0 = tr;
  ti.cdti_ind0 = 1;
  ti.cdti_trk1 = tochdr.cdth_trk1;
  ti.cdti_ind1 = 1;

  /* bertragen */
  ioctl(f, CDROMSTART);
  ioctl(f, CDROMPLAYTRKIND, &ti);
}


stop()
{
  if (repeat != 0) repeat = 0;

  ioctl(f,CDROMSTOP);
}


pause()
{
  if (repeat != 0) repeat = 0;

  subchnl.cdsc_format = CDROM_MSF;
  subchnl.cdsc_audiostatus = CDROM_LEADOUT;
  subchnl.cdsc_trk = CDROM_LEADOUT; 

  ioctl(f, CDROMSUBCHNL, &subchnl);

  if (subchnl.cdsc_audiostatus == 17)
    {
      ioctl(f, CDROMPAUSE);
      return 0;
    }
  if ((subchnl.cdsc_audiostatus == 18) || (subchnl.cdsc_audiostatus == 21))
     {
       if (subchnl.cdsc_trk < 1)
	 {
	   play(1);
	 }
       else
	 {
	   play(subchnl.cdsc_trk);
	 }
       return 0;
     }
  play(1);
}


static void uhr(int sig)
{
  long ti;
  struct tm *tminfo;
  char st[3], min[3], sec[3], outstr[9];
  int x, y;

  if (swhg)
    return;

  /* Ngster aufruf, nur von einem signal aufruf ! */
  if (sig != 128)
    {
      signal(SIGALRM, uhr);
      alarm(1);
    }
  paintstatus();
  getsyx(y, x);
  /* Get Time Date */
  ti = time(&ti);
  tminfo = localtime(&ti);
  /* Copyren der Zahlen in einen String, und 0 davorsetzen */
  sprintf(st, "%d", tminfo -> tm_hour);
  make0(st, 2);
  sprintf(min, "%d", tminfo -> tm_min);
  make0(min, 2);
  sprintf(sec, "%d", tminfo -> tm_sec);
  make0(sec, 2);
  /* Ausgabestring vormatieren */
  sprintf(outstr, "%s:%s:%s", st, min, sec);
  /* Ausgeben */
  gotoxy(65, 10);
  addstr(outstr);
  setsyx(y, x);
  refresh();
}


static void finish(int sig)
{
  swhg = 1;
  /* Herrunterfahren */
  endwin();
  /* Error - Rckgabe */
  if (sig == -1)
    {
      exit(1);
    }
  exit(0);
}


static void winversch(int sig)
{
  if (swhg)
    return;

  signal(SIGWINCH, winversch);
  printf("%c", 7);
  endwin();
  paint();
}
